DevExtreme v26.1 is now available.

Explore our newest features/capabilities and share your thoughts with us.

Your search did not match any results.

JavaScript/jQuery Charts - Bullets

Bullet charts are useful when you need to compare a single measure to a target value. A bullet bar indicates the measure and a vertical line indicates the target value. The bullet also includes a zero level line that indicates zero on the scale.

Backend API
$(() => { const options = { startScaleValue: 0, endScaleValue: 35, tooltip: { customizeTooltip(arg) { return { text: `Current t&#176: ${arg.value}&#176C<br>Average t&#176: ${arg.target}&#176C`, }; }, }, }; const junFirst = $.extend({ value: 23, target: 20, color: '#ebdd8f' }, options); const julFirst = $.extend({ value: 27, target: 24, color: '#e8c267' }, options); const augFirst = $.extend({ value: 20, target: 26, color: '#e55253' }, options); const junSecond = $.extend({ value: 24, target: 22, color: '#ebdd8f' }, options); const julSecond = $.extend({ value: 28, target: 24, color: '#e8c267' }, options); const augSecond = $.extend({ value: 30, target: 24, color: '#e55253' }, options); const junThird = $.extend({ value: 35, target: 24, color: '#ebdd8f' }, options); const julThird = $.extend({ value: 24, target: 26, color: '#e8c267' }, options); const augThird = $.extend({ value: 28, target: 22, color: '#e55253' }, options); const junFourth = $.extend({ value: 29, target: 25, color: '#ebdd8f' }, options); const julFourth = $.extend({ value: 24, target: 27, color: '#e8c267' }, options); const augFourth = $.extend({ value: 21, target: 21, color: '#e55253' }, options); $('.june-1').dxBullet(junFirst); $('.july-1').dxBullet(julFirst); $('.august-1').dxBullet(augFirst); $('.june-2').dxBullet(junSecond); $('.july-2').dxBullet(julSecond); $('.august-2').dxBullet(augSecond); $('.june-3').dxBullet(junThird); $('.july-3').dxBullet(julThird); $('.august-3').dxBullet(augThird); $('.june-4').dxBullet(junFourth); $('.july-4').dxBullet(julFourth); $('.august-4').dxBullet(augFourth); });
<!DOCTYPE html> <html xmlns="http://www.w3.org/1999/xhtml" lang="en"> <head> <title>DevExtreme Demo</title> <meta http-equiv="X-UA-Compatible" content="IE=edge" /> <meta http-equiv="Content-Type" content="text/html; charset=utf-8" /> <meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" /> <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script> <script>window.jQuery || document.write(decodeURIComponent('%3Cscript src="js/jquery.min.js"%3E%3C/script%3E'))</script> <link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/26.1.4/css/dx.light.css" /> <script src="js/dx.all.js?v=26.1.4"></script> <link rel="stylesheet" type="text/css" href="styles.css" /> <script src="index.js"></script> </head> <body class="dx-viewport"> <div class="demo-container"> <div class="long-title"><h3>Daily temperature</h3></div> <div id="chart-demo"> <table class="demo-table"> <tr> <th><div class="dx-screen-reader-only">Week</div></th> <th>June</th> <th>July</th> <th>August</th> </tr> <tr> <th>First week</th> <td><div class="bullet june-1"></div></td> <td><div class="bullet july-1"></div></td> <td><div class="bullet august-1"></div></td> </tr> <tr> <th>Second week</th> <td><div class="bullet june-2"></div></td> <td><div class="bullet july-2"></div></td> <td><div class="bullet august-2"></div></td> </tr> <tr> <th>Third week</th> <td><div class="bullet june-3"></div></td> <td><div class="bullet july-3"></div></td> <td><div class="bullet august-3"></div></td> </tr> <tr> <th>Fourth week</th> <td><div class="bullet june-4"></div></td> <td><div class="bullet july-4"></div></td> <td><div class="bullet august-4"></div></td> </tr> </table> </div> </div> </body> </html>
#chart-demo { height: 440px; width: 100%; } .demo-table { margin-top: 80px; width: 100%; border: 1px solid #c2c2c2; border-collapse: collapse; } .demo-table th, .demo-table td { font-weight: 400; width: 200px; padding: 25px 10px 5px; border: 1px solid #e5e5e5; } .demo-table th { padding: 25px 15px 20px; border: 1px solid #c2c2c2; } .demo-table tr:nth-child(2) td { border-top: 1px solid #c2c2c2; } .demo-table td:first-of-type { border-left: 1px solid #c2c2c2; } .demo-table .bullet { width: 200px; height: 30px; } .long-title h3 { font-family: 'Segoe UI Light', 'Helvetica Neue Light', 'Segoe UI', 'Helvetica Neue', 'Trebuchet MS', Verdana; font-weight: 200; font-size: 28px; text-align: center; margin-bottom: 20px; }

Configure the Bullet Bar

Specify the value property to set the length of the bullet bar. The value should be between the startScaleValue and endScaleValue. If you do not specify the scale range, the startScaleValue is 0 and the endScaleValue is calculated automatically based on measure and target values.

When you arrange several bullets in a column, set the same scale range for them so that their bullet bars can be compared visually.

To change the bar color, use the color property.

Configure the Target and Zero Level Lines

Set the target property to specify the target value. You can also use the targetColor and targetWidth properties to customize the target line appearance.

The zero level line indicates zero and has the same color as the target line. If you want to hide the zero level line, you can disable the showZeroLevel property.

Configure the Tooltip

A tooltip contains information about the measure and target values. To configure the tooltip, use the tooltip object. In this demo, the customizeTooltip function within this object customizes the tooltip content.

Use our DevExpress BI Dashboard to embed interactive business intelligence into your next web app.

The Web Dashboard is a data analysis UI component that you can embed into your ASP.NET Core or Angular, React, and Vue applications with .NET backend. Dashboards allow you to display multiple inter-connected data analysis elements such as grids, charts, maps, gauges, and others: all within an automatically-arranged layout.

The set of components allows you to deploy an all-in-one solution and switch between Viewer and Designer modes directly on the web client (includes adaptive layouts for tablet & mobile).

The Web Dashboard is available as a part of a Universal subscription.

Get Started with DevExpress BI Dashboard | Explore Demos

<template>
<div id="chart-demo">
<div class="long-title"><h3>Daily temperature</h3></div>
<table class="demo-table">
<tbody>
<tr>
<th><div class="dx-screen-reader-only">Week</div></th>
<th>June</th>
<th>July</th>
<th>August</th>
</tr>
<tr
v-for="week in getWeeksData"
:key="week.weekCount"
>
<th>{{ week.weekCount + " week" }}</th>
<td
v-for="data in week.bulletsData"
:key="data.color"
>
<DxBullet
:color="data.color"
:start-scale-value="0"
:end-scale-value="35"
:target="data.target"
:value="data.value"
class="bullet"
>
<DxTooltip :customize-tooltip="customizeTooltip"/>
</DxBullet>
</td>
</tr>
</tbody>
</table>
</div>
</template>
<script setup lang="ts">
import DxBullet, { DxTooltip } from 'devextreme-vue/bullet';
import { service } from './data.ts';
const getWeeksData = service.getWeeksData();
const customizeTooltip = ({ value, target }: any) => ({
text: `Current t°: ${value}°C<br>Average t°: ${target}°C`,
});
</script>
<style>
#chart-demo {
height: 440px;
width: 100%;
}
.demo-table {
margin-top: 80px;
width: 100%;
border: 1px solid #c2c2c2;
border-collapse: collapse;
}
.demo-table th,
.demo-table td {
font-weight: 400;
width: 200px;
padding: 25px 10px 5px;
border: 1px solid #e5e5e5;
}
.demo-table th {
padding: 25px 15px 20px;
border: 1px solid #c2c2c2;
}
.demo-table tr:nth-child(2) td {
border-top: 1px solid #c2c2c2;
}
.demo-table td:first-of-type {
border-left: 1px solid #c2c2c2;
}
.demo-table .bullet {
width: 200px;
height: 30px;
}
.long-title h3 {
font-family:
"Segoe UI Light",
"Helvetica Neue Light",
"Segoe UI",
"Helvetica Neue",
"Trebuchet MS",
Verdana;
font-weight: 200;
font-size: 28px;
text-align: center;
margin-bottom: 20px;
}
</style>
window.exports = window.exports || {};
window.config = {
transpiler: false,
meta: {
'*.vue': {
loader: 'vue-loader',
},
'*.ts': {
loader: 'demo-ts-loader',
},
'*.svg': {
loader: 'svg-loader',
},
'typescript': {
'exports': 'ts',
},
'vue': {
format: 'global',
exports: 'Vue',
esModule: true,
},
'vuex': {
format: 'global',
exports: 'Vuex',
esModule: true,
},
'devextreme/time_zone_utils.js': {
'esModule': true,
},
'devextreme/localization.js': {
'esModule': true,
},
'devextreme/viz/palette.js': {
'esModule': true,
},
'openai': {
'esModule': true,
},
'zod': {
'esModule': true,
},
'zod-to-json-schema': {
'esModule': true,
},
'anti-forgery': {
loader: 'demo-ts-loader',
},
},
paths: {
'project:': '../../../../',
'npm:': 'https://cdn.jsdelivr.net/npm/',
'bundles:': '../../../../bundles/',
'externals:': '../../../../bundles/externals/',
'anti-forgery:': '../../../../shared/anti-forgery/',
'loaders:': '../../../../shared/loaders/',
},
map: {
'anti-forgery': 'anti-forgery:fetch-override.js',
'vue': 'npm:vue@3.5.40/dist/vue.global.js',
'@vue/shared': 'npm:@vue/shared@3.4.26/dist/shared.cjs.prod.js',
'dx-systemjs-vue-browser': 'npm:dx-systemjs-vue-browser@1.1.2/index.js',
'demo-ts-loader': 'loaders:demo-ts-loader.js',
'demo-ts-shared': 'loaders:demo-ts-shared.js',
'vue-loader': 'loaders:demo-vue-loader.js',
'typescript': 'npm:typescript@4.2.4/lib/typescript.js',
'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js',
'svg-loader': 'project:utils/svg-loader.js',
'mitt': 'npm:mitt/dist/mitt.umd.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign',
'devextreme': 'npm:devextreme@link:../../packages/devextreme/artifacts/npm/devextreme/cjs',
'devextreme-vue': 'npm:devextreme-vue@link:../../packages/devextreme-vue/npm/cjs',
'zod': 'externals:zod.bundle.js',
'zod-to-json-schema': 'externals:zod-to-json-schema.bundle.js',
'devextreme-quill': 'npm:devextreme-quill@1.7.10/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.29/dist/dx-diagram.js',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.69/dist/dx-gantt.js',
'inferno': 'npm:inferno@8.2.3/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@8.2.3/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
'@preact/signals-core': 'npm:@preact/signals-core@1.14.4/dist/signals-core.min.js',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.8/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js',
},
packages: {
'devextreme-vue': {
main: 'index.js',
},
'devextreme-vue/common': {
main: 'index.js',
},
'devextreme': {
defaultExtension: 'js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/common/core/events/utils': {
main: 'index',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
],
};
window.process = {
env: {
NODE_ENV: 'production',
},
};
System.config(window.config);
// eslint-disable-next-line
const useTgzInCSB = ['openai'];
let packagesInfo = {
"zod": {
"version": "3.24.4"
},
"zod-to-json-schema": {
"version": "3.24.6"
}
};
const weeksData = [{
weekCount: 'First',
bulletsData: [{
value: 23,
target: 20,
color: '#ebdd8f',
}, {
value: 27,
target: 24,
color: '#e8c267',
}, {
value: 20,
target: 26,
color: '#e55253',
}],
}, {
weekCount: 'Second',
bulletsData: [{
value: 24,
target: 22,
color: '#ebdd8f',
}, {
value: 28,
target: 24,
color: '#e8c267',
}, {
value: 30,
target: 24,
color: '#e55253',
}],
}, {
weekCount: 'Third',
bulletsData: [{
value: 35,
target: 24,
color: '#ebdd8f',
}, {
value: 24,
target: 26,
color: '#e8c267',
}, {
value: 28,
target: 22,
color: '#e55253',
}],
}, {
weekCount: 'Fourth',
bulletsData: [{
value: 29,
target: 25,
color: '#ebdd8f',
}, {
value: 24,
target: 27,
color: '#e8c267',
}, {
value: 21,
target: 21,
color: '#e55253',
}],
}];
export const service = {
getWeeksData() {
return weeksData;
},
};
import { createApp } from 'vue';
import App from './App.vue';
createApp(App).mount('#app');
<!DOCTYPE html>
<html lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/26.1.4/css/dx.light.css" />
<script type="module">
import * as vueCompilerSFC from "https://cdn.jsdelivr.net/npm/@vue/compiler-sfc@3.4.27/dist/compiler-sfc.esm-browser.js";
window.vueCompilerSFC = vueCompilerSFC;
</script>
<script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script>
<script type="text/javascript" src="config.js"></script>
<script type="text/javascript">
System.import("./index.ts");
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div id="app"> </div>
</div>
</body>
</html>

import React from 'react';
import Bullet, { Tooltip } from 'devextreme-react/bullet';
import { service } from './data.ts';
function customizeTooltip(arg: { value: number; target: number; }) {
return {
text: `Current t°: ${arg.value} °C<br>Average t°:${arg.target}°C`,
};
}
function App() {
return (
<div id="chart-demo">
<div className="long-title"><h3>Daily temperature</h3></div>
<table className="demo-table">
<tbody>
<tr>
<th><div className="dx-screen-reader-only">Week</div></th>
<th>June</th>
<th>July</th>
<th>August</th>
</tr>
{service.getWeeksData().map((week, i) => (
<tr key={i}>
<th>{`${week.weekCount} week`}</th>
{week.bulletsData.map((data, j) => (
<td key={j}>
<Bullet
className="bullet"
startScaleValue={0}
endScaleValue={35}
value={data.value}
target={data.target}
color={data.color}
>
<Tooltip customizeTooltip={customizeTooltip} />
</Bullet>
</td>
))}
</tr>
))}
</tbody>
</table>
</div>
);
}
export default App;
import React from 'react';
import Bullet, { Tooltip } from 'devextreme-react/bullet';
import { service } from './data.js';
function customizeTooltip(arg) {
return {
text: `Current t°: ${arg.value} °C<br>Average t°:${arg.target}°C`,
};
}
function App() {
return (
<div id="chart-demo">
<div className="long-title">
<h3>Daily temperature</h3>
</div>
<table className="demo-table">
<tbody>
<tr>
<th>
<div className="dx-screen-reader-only">Week</div>
</th>
<th>June</th>
<th>July</th>
<th>August</th>
</tr>
{service.getWeeksData().map((week, i) => (
<tr key={i}>
<th>{`${week.weekCount} week`}</th>
{week.bulletsData.map((data, j) => (
<td key={j}>
<Bullet
className="bullet"
startScaleValue={0}
endScaleValue={35}
value={data.value}
target={data.target}
color={data.color}
>
<Tooltip customizeTooltip={customizeTooltip} />
</Bullet>
</td>
))}
</tr>
))}
</tbody>
</table>
</div>
);
}
export default App;
import React from 'react';
import ReactDOM from 'react-dom';
import App from './App.tsx';
ReactDOM.render(
<App />,
document.getElementById('app'),
);
const weeksData = [{
weekCount: 'First',
bulletsData: [{
value: 23,
target: 20,
color: '#ebdd8f',
}, {
value: 27,
target: 24,
color: '#e8c267',
}, {
value: 20,
target: 26,
color: '#e55253',
}],
}, {
weekCount: 'Second',
bulletsData: [{
value: 24,
target: 22,
color: '#ebdd8f',
}, {
value: 28,
target: 24,
color: '#e8c267',
}, {
value: 30,
target: 24,
color: '#e55253',
}],
}, {
weekCount: 'Third',
bulletsData: [{
value: 35,
target: 24,
color: '#ebdd8f',
}, {
value: 24,
target: 26,
color: '#e8c267',
}, {
value: 28,
target: 22,
color: '#e55253',
}],
}, {
weekCount: 'Fourth',
bulletsData: [{
value: 29,
target: 25,
color: '#ebdd8f',
}, {
value: 24,
target: 27,
color: '#e8c267',
}, {
value: 21,
target: 21,
color: '#e55253',
}],
}];
export const service = {
getWeeksData() {
return weeksData;
},
};
window.exports = window.exports || {};
window.config = {
transpiler: false,
meta: {
'*.ts': {
loader: 'demo-ts-loader',
},
'*.tsx': {
loader: 'demo-ts-loader',
typescriptOptions: {
jsx: 'react',
},
},
'typescript': {
'exports': 'ts',
},
'anti-forgery': {
loader: 'demo-ts-loader',
},
'react': {
'esModule': true,
},
'devextreme/time_zone_utils.js': {
'esModule': true,
},
'devextreme/localization.js': {
'esModule': true,
},
'devextreme/viz/palette.js': {
'esModule': true,
},
'openai': {
'esModule': true,
},
'zod': {
'esModule': true,
},
'zod-to-json-schema': {
'esModule': true,
},
},
paths: {
'npm:': 'https://cdn.jsdelivr.net/npm/',
'bundles:': '../../../../bundles/',
'externals:': '../../../../bundles/externals/',
'anti-forgery:': '../../../../shared/anti-forgery/',
'loaders:': '../../../../shared/loaders/',
},
defaultExtension: 'js',
map: {
'anti-forgery': 'anti-forgery:fetch-override.js',
'demo-ts-loader': 'loaders:demo-ts-loader.js',
'demo-ts-shared': 'loaders:demo-ts-shared.js',
'typescript': 'npm:typescript@4.2.4/lib/typescript.js',
'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js',
'react': 'npm:react@17.0.2/umd/react.development.js',
'react-dom': 'npm:react-dom@17.0.2/umd/react-dom.development.js',
'prop-types': 'npm:prop-types/prop-types.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign',
'devextreme': 'npm:devextreme@link:../../packages/devextreme/artifacts/npm/devextreme/cjs',
'devextreme-react': 'npm:devextreme-react@link:../../packages/devextreme-react/npm/cjs',
'zod': 'externals:zod.bundle.js',
'zod-to-json-schema': 'externals:zod-to-json-schema.bundle.js',
'devextreme-quill': 'npm:devextreme-quill@1.7.10/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.29/dist/dx-diagram.js',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.69/dist/dx-gantt.js',
'inferno': 'npm:inferno@8.2.3/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@8.2.3/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
'@preact/signals-core': 'npm:@preact/signals-core@1.14.4/dist/signals-core.min.js',
'devextreme-cldr-data': 'npm:devextreme-cldr-data@1.0.3',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.8/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js',
},
packages: {
'devextreme': {
defaultExtension: 'js',
},
'devextreme-react': {
main: 'index.js',
},
'devextreme-react/common': {
main: 'index.js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/common/core/events/utils': {
main: 'index',
},
'devextreme/localization/messages': {
format: 'json',
defaultExtension: 'json',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
],
};
window.process = {
env: {
NODE_ENV: 'production',
},
};
System.config(window.config);
// eslint-disable-next-line
const useTgzInCSB = ['openai'];
let packagesInfo = {
"zod": {
"version": "3.24.4"
},
"zod-to-json-schema": {
"version": "3.24.6"
}
};
import React from 'react';
import ReactDOM from 'react-dom';
import App from './App.js';
ReactDOM.render(<App />, document.getElementById('app'));
const weeksData = [
{
weekCount: 'First',
bulletsData: [
{
value: 23,
target: 20,
color: '#ebdd8f',
},
{
value: 27,
target: 24,
color: '#e8c267',
},
{
value: 20,
target: 26,
color: '#e55253',
},
],
},
{
weekCount: 'Second',
bulletsData: [
{
value: 24,
target: 22,
color: '#ebdd8f',
},
{
value: 28,
target: 24,
color: '#e8c267',
},
{
value: 30,
target: 24,
color: '#e55253',
},
],
},
{
weekCount: 'Third',
bulletsData: [
{
value: 35,
target: 24,
color: '#ebdd8f',
},
{
value: 24,
target: 26,
color: '#e8c267',
},
{
value: 28,
target: 22,
color: '#e55253',
},
],
},
{
weekCount: 'Fourth',
bulletsData: [
{
value: 29,
target: 25,
color: '#ebdd8f',
},
{
value: 24,
target: 27,
color: '#e8c267',
},
{
value: 21,
target: 21,
color: '#e55253',
},
],
},
];
export const service = {
getWeeksData() {
return weeksData;
},
};
<!DOCTYPE html>
<html lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/26.1.4/css/dx.light.css" />
<link rel="stylesheet" type="text/css" href="styles.css" />
<script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script>
<script type="text/javascript" src="config.js"></script>
<script type="text/javascript">
System.import("./index.tsx");
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div id="app"></div>
</div>
</body>
</html>
#chart-demo {
height: 440px;
width: 100%;
}
.demo-table {
margin-top: 80px;
width: 100%;
border: 1px solid #c2c2c2;
border-collapse: collapse;
}
.demo-table th,
.demo-table td {
font-weight: 400;
width: 200px;
padding: 25px 10px 5px;
border: 1px solid #e5e5e5;
}
.demo-table th {
padding: 25px 15px 20px;
border: 1px solid #c2c2c2;
}
.demo-table tr:nth-child(2) td {
border-top: 1px solid #c2c2c2;
}
.demo-table td:first-of-type {
border-left: 1px solid #c2c2c2;
}
.demo-table .bullet {
width: 200px;
height: 30px;
}
.long-title h3 {
font-family:
"Segoe UI Light",
"Helvetica Neue Light",
"Segoe UI",
"Helvetica Neue",
"Trebuchet MS",
Verdana;
font-weight: 200;
font-size: 28px;
text-align: center;
margin-bottom: 20px;
}

<div class="long-title"><h3>Daily temperature</h3></div>
<div id="chart-demo">
<table class="demo-table">
<tr>
<th><div class="dx-screen-reader-only">Week</div></th>
<th>June</th>
<th>July</th>
<th>August</th>
</tr>
@for(week of weeksData; track week) {
<tr>
<th>{{ week.weekCount }} week</th>
@for(bullet of week.bulletsData; track bullet) {
<td>
<dx-bullet
class="bullet"
[startScaleValue]="0"
[endScaleValue]="35"
[value]="bullet.value"
[target]="bullet.target"
[color]="bullet.color"
>
<dxo-bullet-tooltip
[customizeTooltip]="customizeTooltip"
></dxo-bullet-tooltip>
</dx-bullet>
</td>
}
</tr>
}
</table>
</div>
import { bootstrapApplication } from '@angular/platform-browser';
import { Component, enableProdMode, provideZoneChangeDetection } from '@angular/core';
import { DxBulletModule } from 'devextreme-angular';
import { Week, Service } from './app.service';
if (!/localhost/.test(document.location.host)) {
enableProdMode();
}
let modulePrefix = '';
// @ts-ignore
if (window && window.config?.packageConfigPaths) {
modulePrefix = '/app';
}
@Component({
selector: 'demo-app',
templateUrl: `app/app.component.html`,
styleUrls: [`app/app.component.css`],
providers: [Service],
imports: [
DxBulletModule,
],
})
export class AppComponent {
weeksData: Week[];
constructor(service: Service) {
this.weeksData = service.getWeeksData();
}
customizeTooltip(arg) {
return {
text: `Current t°: ${arg.value}°C<br>Average t°: ${arg.target}°C`,
};
}
}
bootstrapApplication(AppComponent, {
providers: [
provideZoneChangeDetection({ eventCoalescing: true, runCoalescing: true }),
],
});
::ng-deep #chart-demo {
height: 440px;
width: 100%;
}
::ng-deep .demo-table {
margin-top: 80px;
width: 100%;
border: 1px solid #c2c2c2;
border-collapse: collapse;
}
::ng-deep .demo-table th,
::ng-deep .demo-table td {
font-weight: 400;
width: 200px;
padding: 25px 10px 5px;
border: 1px solid #e5e5e5;
}
::ng-deep .demo-table th {
padding: 25px 15px 20px;
border: 1px solid #c2c2c2;
}
::ng-deep .demo-table tr:nth-child(2) td {
border-top: 1px solid #c2c2c2;
}
::ng-deep .demo-table td:first-of-type {
border-left: 1px solid #c2c2c2;
}
::ng-deep .demo-table .bullet {
width: 200px;
height: 30px;
}
::ng-deep .long-title h3 {
font-family: 'Segoe UI Light', 'Helvetica Neue Light', 'Segoe UI', 'Helvetica Neue', 'Trebuchet MS', Verdana;
font-weight: 200;
font-size: 28px;
text-align: center;
margin-bottom: 20px;
}
import {
Injectable,
} from '@angular/core';
export class Week {
weekCount: string;
bulletsData: Bullet[];
}
export class Bullet {
value: number;
target: number;
color?: string;
}
const weeksData: Week[] = [{
weekCount: 'First',
bulletsData: [{
value: 23,
target: 20,
color: '#ebdd8f',
}, {
value: 27,
target: 24,
color: '#e8c267',
}, {
value: 20,
target: 26,
color: '#e55253',
}],
}, {
weekCount: 'Second',
bulletsData: [{
value: 24,
target: 22,
color: '#ebdd8f',
}, {
value: 28,
target: 24,
color: '#e8c267',
}, {
value: 30,
target: 24,
color: '#e55253',
}],
}, {
weekCount: 'Third',
bulletsData: [{
value: 35,
target: 24,
color: '#ebdd8f',
}, {
value: 24,
target: 26,
color: '#e8c267',
}, {
value: 28,
target: 22,
color: '#e55253',
}],
}, {
weekCount: 'Fourth',
bulletsData: [{
value: 29,
target: 25,
color: '#ebdd8f',
}, {
value: 24,
target: 27,
color: '#e8c267',
}, {
value: 21,
target: 21,
color: '#e55253',
}],
}];
@Injectable()
export class Service {
getWeeksData(): Week[] {
return weeksData;
}
}
// In real applications, you should not transpile code in the browser.
// You can see how to create your own application with Angular and DevExtreme here:
// https://js.devexpress.com/Documentation/Guide/Angular_Components/Getting_Started/Create_a_DevExtreme_Application/
const componentNames = [
'accordion',
'action-sheet',
'autocomplete',
'bar-gauge',
'box',
'bullet',
'button-group',
'button',
'calendar',
'card-view',
'chart',
'chat',
'check-box',
'circular-gauge',
'color-box',
'context-menu',
'data-grid',
'date-box',
'date-range-box',
'defer-rendering',
'diagram',
'draggable',
'drawer',
'drop-down-box',
'drop-down-button',
'file-manager',
'file-uploader',
'filter-builder',
'form',
'funnel',
'gallery',
'gantt',
'html-editor',
'linear-gauge',
'list',
'load-indicator',
'load-panel',
'lookup',
'map',
'menu',
'multi-view',
'nested',
'number-box',
'pagination',
'pie-chart',
'pivot-grid-field-chooser',
'pivot-grid',
'polar-chart',
'popover',
'popup',
'progress-bar',
'radio-group',
'range-selector',
'range-slider',
'recurrence-editor',
'resizable',
'responsive-box',
'sankey',
'scheduler',
'scroll-view',
'select-box',
'slider',
'sortable',
'sparkline',
'speech-to-text',
'speed-dial-action',
'splitter',
'stepper',
'switch',
'tab-panel',
'tabs',
'tag-box',
'text-area',
'text-box',
'tile-view',
'toast',
'toolbar',
'tooltip',
'tree-list',
'tree-map',
'tree-view',
'validation-group',
'validation-summary',
'validator',
'vector-map',
];
window.exports = window.exports || {};
window.config = {
transpiler: false,
meta: {
'*.ts': {
loader: 'demo-ts-loader',
},
'typescript': {
'exports': 'ts',
},
'anti-forgery': {
loader: 'demo-ts-loader',
},
'devextreme/time_zone_utils.js': {
'esModule': true,
},
'devextreme/localization.js': {
'esModule': true,
},
'devextreme/viz/palette.js': {
'esModule': true,
},
'@angular/platform-browser-dynamic': {
'esModule': true,
},
'@angular/platform-browser': {
'esModule': true,
},
'@angular/core': {
'esModule': true,
},
'@angular/common': {
'esModule': true,
},
'@angular/common/http': {
'esModule': true,
},
'@angular/animations': {
'esModule': true,
},
'@angular/forms': {
'esModule': true,
},
'openai': {
'esModule': true,
},
'zod': {
'esModule': true,
},
'zod-to-json-schema': {
'esModule': true,
},
},
paths: {
'npm:': 'https://cdn.jsdelivr.net/npm/',
'bundles:': '../../../../bundles/',
'externals:': '../../../../bundles/externals/',
'anti-forgery:': '../../../../shared/anti-forgery/',
'loaders:': '../../../../shared/loaders/',
},
map: {
'anti-forgery': 'anti-forgery:fetch-override.js',
'demo-ts-loader': 'loaders:demo-ts-loader.js',
'demo-ts-shared': 'loaders:demo-ts-shared.js',
'typescript': 'npm:typescript@4.2.4/lib/typescript.js',
'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js',
/* @angular */
'@angular/compiler': 'bundles:@angular/compiler.umd.js',
'@angular/platform-browser-dynamic': 'bundles:@angular/platform-browser-dynamic.umd.js',
'@angular/core': 'bundles:@angular/core.umd.js',
'@angular/core/primitives/signals': 'bundles:@angular/core.primitives.signals.umd.js',
'@angular/core/primitives/di': 'bundles:@angular/core.primitives.di.umd.js',
'@angular/common': 'bundles:@angular/common.umd.js',
'@angular/common/http': 'bundles:@angular/common-http.umd.js',
'@angular/platform-browser': 'bundles:@angular/platform-browser.umd.js',
'@angular/platform-browser/animations': 'bundles:@angular/platform-browser.umd.js',
'@angular/forms': 'bundles:@angular/forms.umd.js',
/* devextreme */
'devextreme': 'npm:devextreme@link:../../packages/devextreme/artifacts/npm/devextreme/cjs',
'devextreme-quill': 'npm:devextreme-quill@1.7.10/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.29',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.69',
/* devextreme-angular umd maps */
'devextreme-angular': 'bundles:devextreme-angular/devextreme-angular.umd.js',
'devextreme-angular/common/ai-integration': 'bundles:devextreme-angular/devextreme-angular-common-ai-integration.umd.js',
'devextreme-angular/core': 'bundles:devextreme-angular/devextreme-angular-core.umd.js',
'devextreme-angular/common/charts': 'bundles:devextreme-angular/devextreme-angular-common-charts.umd.js',
'devextreme-angular/common/core/animation': 'bundles:devextreme-angular/devextreme-angular-common-core-animation.umd.js',
'devextreme-angular/common/core/environment': 'bundles:devextreme-angular/devextreme-angular-common-core-environment.umd.js',
'devextreme-angular/common/core/events': 'bundles:devextreme-angular/devextreme-angular-common-core-events.umd.js',
'devextreme-angular/common/core/localization': 'bundles:devextreme-angular/devextreme-angular-common-core-localization.umd.js',
'devextreme-angular/common/core': 'bundles:devextreme-angular/devextreme-angular-common-core.umd.js',
'devextreme-angular/common/data/custom-store': 'bundles:devextreme-angular/devextreme-angular-common-data-custom-store.umd.js',
'devextreme-angular/common/data': 'bundles:devextreme-angular/devextreme-angular-common-data.umd.js',
'devextreme-angular/common/export/excel': 'bundles:devextreme-angular/devextreme-angular-common-export-excel.umd.js',
'devextreme-angular/common/export/pdf': 'bundles:devextreme-angular/devextreme-angular-common-export-pdf.umd.js',
'devextreme-angular/common/export': 'bundles:devextreme-angular/devextreme-angular-common-export.umd.js',
'devextreme-angular/common/grids': 'bundles:devextreme-angular/devextreme-angular-common-grids.umd.js',
'devextreme-angular/common': 'bundles:devextreme-angular/devextreme-angular-common.umd.js',
'devextreme-angular/http': 'bundles:devextreme-angular/devextreme-angular-http.umd.js',
'devextreme-angular/core/tokens': 'bundles:devextreme-angular/devextreme-angular-core-tokens.umd.js',
...componentNames.reduce((acc, name) => {
acc[`devextreme-angular/ui/${name}`] = `bundles:devextreme-angular/devextreme-angular-ui-${name}.umd.js`;
acc[`devextreme-angular/ui/${name}/nested`] = `bundles:devextreme-angular/devextreme-angular-ui-${name}-nested.umd.js`;
return acc;
}, {}),
'zod': 'externals:zod.bundle.js',
'zod-to-json-schema': 'externals:zod-to-json-schema.bundle.js',
'tslib': 'npm:tslib/tslib.js',
'rxjs': 'npm:rxjs@7.5.3/dist/bundles/rxjs.umd.js',
'rxjs/operators': 'npm:rxjs@7.5.3/dist/cjs/operators/index.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign',
'inferno': 'npm:inferno@8.2.3/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@8.2.3/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
'@preact/signals-core': 'npm:@preact/signals-core@1.14.4/dist/signals-core.min.js',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.8/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js',
'zone.js': 'npm:zone.js@0.16.2/bundles/zone.umd.js',
},
packages: {
'app': {
main: './app.component.ts',
defaultExtension: 'ts',
},
'devextreme': {
defaultExtension: 'js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/common/core/events/utils': {
main: 'index',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
'rxjs': {
defaultExtension: 'js',
},
'rxjs/operators': {
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
'npm:rxjs@7.5.3/package.json',
'npm:rxjs@7.5.3/operators/package.json',
'npm:devexpress-diagram@2.2.29/package.json',
'npm:devexpress-gantt@4.1.69/package.json',
],
};
window.process = {
env: {
NODE_ENV: 'production',
},
};
System.config(window.config);
// eslint-disable-next-line no-console
// System.import('@angular/compiler').catch(console.error.bind(console));
// eslint-disable-next-line
const useTgzInCSB = ['openai'];
let packagesInfo = {
"zod": {
"version": "3.24.4"
},
"zod-to-json-schema": {
"version": "3.24.6"
},
"@angular/core": {
"version": "22.1.0"
},
"core-js": {
"version": "2.6.12"
},
"typescript": {
"version": "6.0.3"
},
"zone.js": {
"version": "0.16.2"
}
};
<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml" lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/26.1.4/css/dx.light.css" />
<script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/zone.js@0.16.2/bundles/zone.umd.js"></script>
<script src="https://cdn.jsdelivr.net/npm/reflect-metadata@0.1.13/Reflect.js"></script>
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script>
<script src="config.js"></script>
<script>
System.import("app").catch(console.error.bind(console));
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<demo-app>Loading...</demo-app>
</div>
</body>
</html>